'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = wrapRouter;
function patchObject(target, name, patchFn) {
  var delegateName = name;
  var delegate = target[delegateName];
  if (!delegate) {
    delegate = target[delegateName] = target[name];
    target[name] = createNamedFn(name, patchFn(delegate, delegateName, name));
  }
  return delegate;
}

function createNamedFn(name, delegate) {
  try {
    return Function('f', 'return function ' + name + '(){return f(this, arguments)}')(delegate); // eslint-disable-line
  } catch (e) {
    // if we fail, we must be CSP, just return delegate.
    return function () {
      return delegate(this, arguments);
    };
  }
}

function patchRouter(router, listener) {
  patchObject(router, 'componentWillMount', function (delegate) {
    return function (self, args) {
      listener(self, args);
    };
  });
}

function wrapRouter(Router, listener) {
  patchRouter(Router.prototype, listener);
  return Router;
}