function patchObject(target, name, patchFn) {
  let delegateName = name;
  let delegate = target[delegateName];
  if (!delegate) {
    delegate = target[delegateName] = target[name];
    target[name] = createNamedFn(name, patchFn(delegate, delegateName, name));
  }
  return delegate;
}

function createNamedFn(name, delegate) {
  try {
    return Function('f', 'return function ' + name + '(){return f(this, arguments)}')(delegate); // eslint-disable-line
  } catch (e) {
    // if we fail, we must be CSP, just return delegate.
    return function () {
      return delegate(this, arguments);
    }
  }
}

function patchRouter(router, listener) {
    patchObject(router, 'componentWillMount', (delegate) => {
      return (self, args) => {
        listener(self, args);
      };
    });
}

export default function wrapRouter(Router, listener) {
  patchRouter(Router.prototype, listener);
  return Router;
}